function GameConnection::showPowerupInfo(%cl)
{
	if(!isObject(%pl = %cl.player)) return;
	%info_Blast = "<color:FF0000>BLAST\tDrop extra tiles by using your jet key!";
	%info_Mine = "<color:FF8000>MINE\tTurn a tile into a trapped powerup by using your jet key!";
	%info_Jet = "<color:FFFF00>JET\tFly across gaps with this short-duration jetpack!";
	%info_Regen = "<color:00FF00>REGEN\tRestore dropped tiles by using your jet key!";
	%info_Icy = "<color:0080FF>ICY\tCreate a slippery ice patch by using your jet key!";
	%info_Blink = "<color:0000FF>BLINK\tAutomatically teleports you to the next safe tile if you fall!<br><color:FF0000>WARNING\c7: You must be running for Blink to work.";
	%info_Sniper = "<color:8000FF>SNIPER\tDrop tiles far away by using your jet key!";
	%info_DJump = "<color:FFFFFF>DOUBLE JUMP\tJump a second time while in mid-air!";
	
	//Supercharged powerups.
	%info_["Blast!"] = "<color:FF0000>SHOCKWAVE\tDrop a large area in front of you by using your jet key!";
	%info_["Mine!"] = "<color:FF8000>NUKE\tTurn a tile into a nuclear bomb by using your jet key!";
	%info_["Blink!"] = "<color:0000FF>TELEPORT\tTeleport to a specific tile by using your jet key!";
	%info_["Sniper!"] = "<color:8000FF>T2 SNIPER\tDrop a Blast-sized area anywhere on the map!";
	%info_["DJump!"] = "<color:FFFFFF>AIR JUMP\tJump whenever you want while in mid-air!";
	
	if((%info = %info_[%pl.currentPowerup]) !$= "")
		%cl.centerPrint(getField(%info, 0)@"\c6 powerup!<br>\c7"@getField(%info, 1), 3);
}

function GameConnection::showPowerupPrint(%cl)
{
	if(!isObject(%pl = %cl.player)) return;
	%info_Blast = "<color:FF0000>BLAST\tcharge\tcharges";
	%info_Mine = "<color:FF8000>MINE\tmine\tmines";
	%info_Jet = "<color:FFFF00>JET\tsecond\tseconds";
	%info_Regen = "<color:00FF00>REGEN\ttile\ttiles";
	%info_Icy = "<color:0080FF>ICY\tcharge\tcharges";
	%info_Blink = "<color:0000FF>BLINK\tstep\tsteps";
	%info_Sniper = "<color:8000FF>SNIPER\tshot\tshots";
	%info_DJump = "<color:FFFFFF>DOUBLE JUMP\tjump\tjumps";
	
	//Supercharged powerups.
	%info_["Blast!"] = "<color:FF0000>SHOCKWAVE\tcharge\tcharges";
	%info_["Mine!"] = "<color:FF8000>NUKE\tnuke\tnukes";
	%info_["Blink!"] = "<color:0000FF>TELEPORT\twarp\twarps";
	%info_["Sniper!"] = "<color:8000FF>T2 SNIPER\tshot\tshots";
	%info_["DJump!"] = "<color:FFFFFF>AIR JUMP\tjump\tjumps";
	
	if((%info = %info_[%pl.currentPowerup]) !$= "")
	{
		if(%pl.currentPowerup $= "JET")
		{
			%value = mCeil(%pl.powerupCharge * 10) / 10;
			%cl.bottomPrint(getField(%info, 0)@"\c6 ("@mFloatLength(%value, 1) SPC getField(%info, 2 - (%value == 1))@")");
		}
		else %cl.bottomPrint(getField(%info, 0)@"\c6 ("@%pl.powerupCharge SPC getField(%info, 2 - (%pl.powerupCharge == 1))@")");
	}
}

function Player::UseBlast(%this, %size, %range)
{
	if(!isObject(%cl = %this.client) || %this.powerupCharge <= 0) return;
	%eye = %this.getEyePoint(); %dir = %this.getEyeVector(); if(%range $= "") %range = 5;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, %range)), $Typemasks::fxBrickObjectType);
	if(isObject(%obj = firstWord(%ray)))
	{
		if(!SpleefArena.isMember(%obj)) return;
		%this.playThread(0, "activate2");
		%fore = %this.getForwardVector();
		%dir = mAtan(getWord(%fore, 0), getWord(%fore, 1));
		%dir += 3.14159265; %dir /= 6.28319 / 8;
		%dir = mFloatLength(%dir, 0); if(%dir == 8) %dir = 0;
		%obj[-1+%objs++] = %obj; %hasObj[%obj] = 1;
		for(%i=0;%i<%size;%i++)
		{
			if(%dir % 2)
			{
				%count = %objs;
				for(%j=0;%j<%count;%j++)
				{
					%obj = %obj[%j];
					%ang = (%dir + 1) * (6.28319 / 8) - 3.14159265;
					%fore = mSin(%ang) SPC mCos(%ang);
					%shift = vectorScale(%fore, 4);
					%end = vectorAdd(%pos0 = %obj.getPosition(), %shift);
					%ray = containerRaycast(vectorAdd(%end, "0 0 0.2"), %end, $Typemasks::fxBrickAlwaysObjectType);
					if(isObject(%hit = firstWord(%ray)) && !%hasObj[%hit]) { %obj[-1+%objs++] = %hit; %hasObj[%hit] = 1; }
					%pos1 = %end; %shift = -getWord(%shift, 1) SPC getWord(%shift, 0);   //Turn left
					for(%k=0;%k<2;%k++)
					{
						%end = vectorAdd(%pos[%k], %shift);
						%ray = containerRaycast(vectorAdd(%end, "0 0 0.2"), %end, $Typemasks::fxBrickAlwaysObjectType);
						if(isObject(%hit = firstWord(%ray)) && !%hasObj[%hit]) { %obj[-1+%objs++] = %hit; %hasObj[%hit] = 1; }
					}
				}
			}
			else
			{
				%count = %objs;
				for(%j=0;%j<%count;%j++)
				{
					%obj = %obj[%j];
					%ang = %dir * (6.28319 / 8) - 3.14159265;
					%fore = mSin(%ang) SPC mCos(%ang);
					%shift = vectorScale(%fore, 4);
					%end = vectorAdd(%pos = %obj.getPosition(), %shift);
					%ray = containerRaycast(vectorAdd(%end, "0 0 0.2"), %end, $Typemasks::fxBrickAlwaysObjectType);
					if(isObject(%hit = firstWord(%ray)) && !%hasObj[%hit]) { %obj[-1+%objs++] = %hit; %hasObj[%hit] = 1; } %pos = %end;
					%end0 = vectorAdd(%pos, getWord(%shift, 1) SPC -getWord(%shift, 0));   //Turn right
					%end1 = vectorAdd(%pos, -getWord(%shift, 1) SPC getWord(%shift, 0));   //Turn left
					for(%k=0;%k<2;%k++)
					{
						%ray = containerRaycast(vectorAdd(%end[%k], "0 0 0.2"), %end[%k], $Typemasks::fxBrickAlwaysObjectType);
						if(isObject(%hit = firstWord(%ray)) && !%hasObj[%hit]) { %obj[-1+%objs++] = %hit; %hasObj[%hit] = 1; }
					}
				}
			}
			%posCount = 0;
		}
		for(%i=0;%i<%objs;%i++)
			if(!%obj[%i].isFakeDead())
				%obj[%i].KillSpleefBrick(%cl);
	}
	else return;
	%this.powerupCharge--; %cl.showPowerupPrint();
}