$Spleef::APowerColors = 7;
$Spleef::BPowerColors = 14;
//Player.playAudio(0, RewardSound);

function CreateSpleefHandler()
{
	if(isObject(SpleefArena))
		SpleefArena.delete();
	%arena = new SimSet(SpleefArena);
	%groups = MainBrickgroup.getCount();
	for(%i=0;%i<%groups;%i++)
	{
		%group = MainBrickgroup.getObject(%i);
		%bricks = %group.getCount();
		for(%j=0;%j<%bricks;%j++)
		{
			%brick = %group.getObject(%j);
		//	if(%brick.getDatablock().uiName $= "Spleef Tile")
			if(getWord(%brick.getPosition(), 2) == 16.3)
				%arena.add(%brick);
		}
	}
	%count = %arena.getCount();
	for(%i=0;%i<%count;%i++) %arena.getObject(%i).CheckNeighbors();
	SpleefSpecialsTick();
}

function RestoreSpleefArena()
{
	if(isObject(SpleefArena))
	{
		%useLives = SpleefArena.useLives;
		%lifeCount = SpleefArena.lifeCount;
		%dropTiles = SpleefArena.dropTiles;
		SpleefArena.delete();
	}
	CreateSpleefHandler();
	SpleefArena.useLives = %useLives;
	SpleefArena.lifeCount = %lifeCount;
	SpleefArena.dropTiles = %dropTiles;
	%bricks = SpleefArena.getCount();
	for(%i=0;%i<%bricks;%i++)
	{
		%brick = SpleefArena.getObject(%i);
		%brick.RestoreTile();
		%brick.powerup = "";
		%brick.setColorFX(0);
		%brick.setEmitter(0);
		if(%brick.origColor !$= "")
		{ %brick.setColor(%brick.origColor); }
		else if(%brick.prevColor !$= "")
		{ %brick.setColor(%brick.prevColor); }
		%brick.origColor = ""; %brick.prevColor = "";
		cancel(%brick.trapLoop); %brick.TrapClient = "";
		cancel(%brick.CheckIslandSched);
		cancel(%brick.UnfreezeSched);
		%brick.TrappedPowerup = 0; %brick.lastDropper = "";
		%brick.icyTile = 0;
	}
	%count = ClientGroup.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(!%cl.hasSpawnedOnce)
			continue;
		%cl.schedule(1000, "spleefRespawn");
	}
	%list = getPowerupList();
	for(%i=0;%i<getWordCount(%list);%i++)
	{
		%power = getWord(%list, %i);
		SpleefArena.powerup[%power] = "";
		SpleefArena.lastSpawn_[%power] = "";
	}
	cancel($DropTick);
	cancel($SpecialsTick);
	schedule(3000, 0, "SpleefSpecialsTick");
	if(SpleefArena.dropTiles)
		$DropTick = schedule(300000, 0, "SpleefDropTilesTick");
}

function SpleefDropTilesTick()
{
	cancel($DropTick);
	if(isObject(SpleefArena) && (%count = SpleefArena.getCount()) != 0)
	{
		%tile = SpleefArena.getObject(getRandom(0, %count - 1));
		%tile.KillSpleefBrick();
	}
	$DropTick = schedule(500, 0, "SpleefDropTilesTick");
}

function GameConnection::spleefRespawn(%cl)
{
	%cl.spleefLives = getMax(SpleefArena.lifeCount, 1);
	%cl.instantRespawn();
}

function getPowerupList()
{ return "Blast Mine Jet Regen Icy Blink Sniper ??? DJump"; }

function SpleefSpecialsTick()
{
	cancel($SpecialsTick);
	$SpecialsTick = schedule(100, 0, "SpleefSpecialsTick"); %arena = SpleefArena;
	if(!SpleefArena.useLives && (%arena.deadBricks / (%arena.getCount() + %arena.deadBricks) >= 0.6) && !isEventPending($SpleefRestore))
	{
		messageAll('', "\c6The arena is destroyed! Resetting the arena!");
		$SpleefRestore = schedule(5000, 0, "RestoreSpleefArena");
	}
	%list = getPowerupList(); %power = getWord(%list, getRandom(0, getWordCount(%list) - 1));
	if(isObject(%brick = %arena.powerup[%power]) && SpleefArena.isMember(%brick)) return;
	if(vectorDist(%arena.lastSpawn_[%power], getSimTime()) < 45000) return;
	%brick = %arena.getObject(getRandom(0, %arena.getCount() - 1));
	if(%brick.powerup !$= "") return;
	%brick.powerup = %power; %brick.setColorFX(4);
	%brick.setEmitter(PongExplosionEmitter);
	if(%brick.origColor $= "") %brick.origColor = %brick.getColorID();
	switch$(%power)
	{
		case "Blast": %color = $Spleef::APowerColors + 0;
		case "Mine": %color = $Spleef::APowerColors + 1;
		case "Jet": %color = $Spleef::APowerColors + 2;
		case "Regen": %color = $Spleef::APowerColors + 3;
		case "Icy": %color = $Spleef::APowerColors + 4;
		case "Blink": %color = $Spleef::APowerColors + 5;
		case "Sniper": %color = $Spleef::APowerColors + 6;
		case "???": %color = $Spleef::BPowerColors + 0; %brick.setColorFX(6); %brick.LottoLoop();
		case "DJump": %color = $Spleef::BPowerColors + 0;
	}
	if(%brick.icyTile)
	{
		%brick.prevColor = %color;
		%brick.setColorFX(0);
	}
	else %brick.setColor(%color);
	SpleefArena.powerup[%power] = %brick;
	cancel($SpecialsTick); $SpecialsTick = schedule(3000, 0, "SpleefSpecialsTick");
}

function fxDtsBrick::RestoreTile(%brick)
{
	%brick.respawn(); SpleefArena.add(%brick);
	cancel(%brick.deadSched); %brick.disappear(0);
	%brick.powerup = ""; %brick.setColorFX(0);
	%brick.setEmitter(0); %brick.trappedPickup = 0;
	if(%brick.origColor !$= "")
		%brick.setColor(%brick.origColor);
	%brick.origColor = ""; %brick.prevColor = "";
	%brick.icyTile = 0;
}

function fxDtsBrick::UnfreezeTile(%brick)
{
	%brick.icyTile = 0;
	if(%brick.prevColor !$= "")
	{ %brick.setColor(%brick.prevColor); %brick.prevColor = ""; }
	else if(%brick.origColor !$= "")
	{ %brick.setColor(%brick.origColor); %brick.origColor = ""; }
	if(%brick.powerup $= "" || %brick.trappedPowerup) %brick.setColorFX(0);
	else if(%brick.powerup $= "???") %brick.setColorFX(6);
	else %brick.setColorFX(4);
}

package SpleefArena
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(%trig == 2 && isObject(%cl = %this.client))
		{
			switch$(%this.currentPowerup)
			{
				case "DJump":
					if(!%tog || %this.powerupCharge <= 0) return;
					%this.schedule(0, "DJumpCheck", %this.getVelocity());
				case "DJump!":
					if(!%tog || %this.powerupCharge < %this.hasDJumped + 1) return;
					%this.schedule(0, "DJumpCheck", %this.getVelocity());
			}
		}
		else if(%trig == 4 && isObject(%cl = %this.client))
		{
			if(%tog) %this.Spleef_JetMonitor(getSimTime());
			else cancel(%this.Spleef_JetLoop);
			switch$(%this.currentPowerup)
			{
				case "Blast":
					if(!%tog) return;
					%this.UseBlast(1);
				case "Mine":
					if(!%tog || %this.powerupCharge < 1) return;
					%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
					%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 5)), $Typemasks::fxBrickObjectType);
					if(isObject(%obj = firstWord(%ray)))
					{
						if(!SpleefArena.isMember(%obj)) return;
						if(%obj.powerup !$= "" || %obj.trappedPowerup) return;   //Can't trap legit powerups.
						%this.playThread(0, "activate2");
						//Should this be delayed? Should it act like it's really the only one (take the powerup variable)?
						if(%obj.origColor $= "") %obj.origColor = %obj.getColorID();
						%obj.setColor(getRandom(7, 13)); %obj.setColorFX(4);
						%obj.setEmitter(PongExplosionEmitter);
						%obj.trappedPowerup = 1;
						%obj.TrapClient = %cl;
					}
					else return;
					%this.powerupCharge--; %cl.bottomPrint("<color:FF8000>MINE\c6 ("@%this.powerupCharge@" mine"@(%this.powerupCharge==1?"":"s")@")");
				case "Regen":
					if(!%tog || %this.powerupCharge < 1) return;
					%arena = SpleefArena; if(%arena.deadBricks <= 0) return;
					%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
					%height = 16.4 - getWord(%eye, 2);
					%scale = %height / getWord(%dir, 2); if(%scale <= 0) return;
					%hit = getWords(vectorAdd(%eye, vectorScale(getWords(%dir, 0, 1), %scale)), 0, 1)@" 16.4";
					if(vectorDist(%hit, %eye) > 8) return;
					%x = mFloatLength((getWord(%hit, 0) - 2) / 4, 0) * 4 + 2;
					%y = mFloatLength((getWord(%hit, 1) - 2) / 4, 0) * 4 + 2;
					%pos = %x SPC %y SPC 16.3;
					for(%i=0;%i<%arena.deadBricks;%i++)
					{
						%brick = %arena.deadBrick[%i];
						if(vectorDist(%brick.getPosition(), %pos) <= 0.05)
						{
							%brick.RestoreTile();
							%brick.noBreakTime = getSimTime();
							%brick.CheckIslandSched = %brick.schedule(2000, "CheckIsland");
							%shift++;
						}
						else %arena.deadBrick[%i - %shift] = %arena.deadBrick[%i];
					}
					%arena.deadBricks -= %shift; if(%shift == 0) return; %this.playThread(0, "activate2");
					%this.powerupCharge--; %cl.bottomPrint("<color:00FF00>REGEN\c6 ("@%this.powerupCharge@" tile"@(%this.powerupCharge==1?"":"s")@")");
				case "Icy":
					if(!%tog || %this.powerupCharge < 1) return;
					%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
					%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 5)), $Typemasks::fxBrickObjectType);
					if(isObject(%brick = firstWord(%ray)))
					{
						if(!SpleefArena.isMember(%brick)) return;
						%this.playThread(0, "activate2");
						initContainerBoxSearch(%pos = %brick.getPosition(), "24 24 0.05", $Typemasks::fxBrickObjectType);
						while(isObject(%obj = containerSearchNext()))
						if(SpleefArena.isMember(%obj) && vectorDist(%pos, %loc = %obj.getPosition()) < 13)
						{
							if(%obj.origColor $= "") %obj.origColor = %obj.getColorID();
							if(%obj.prevColor $= "") %obj.prevColor = %obj.getColorID();
							%obj.icyTile = 1; %obj.setColor(11); %obj.setColorFX(0);
							%time = getMax(getTimeRemaining(%obj.unfreezeSched), 60000 - vectorDist(%pos, %loc) * 3000);
							cancel(%obj.unfreezeSched); %obj.unfreezeSched = %obj.schedule(%time, "UnfreezeTile");
						}
					}
					else return;
					%this.powerupCharge--; %cl.bottomPrint("<color:0080FF>ICY\c6 ("@%this.powerupCharge@" charge"@(%this.powerupCharge==1?"":"s")@")");
				case "Sniper":
					if(!%tog || %this.powerupCharge < 1) return;
					%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
					%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 240)), $Typemasks::fxBrickObjectType);
					if(isObject(%obj = firstWord(%ray)))
					{
						if(!SpleefArena.isMember(%obj)) return;
						%this.playThread(0, "activate2");
						if(!%obj.KillSpleefBrick(%cl)) return;
					}
					else return;
					%this.powerupCharge--; %cl.bottomPrint("<color:8000FF>SNIPER\c6 ("@%this.powerupCharge@" shot"@(%this.powerupCharge==1?"":"s")@")");
				
				//Supercharged powerups
				case "Blast!":
					if(!%tog) return;
					%this.UseBlast(2);
				case "Mine!":
					if(!%tog || %this.powerupCharge < 1) return;
					%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
					%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 5)), $Typemasks::fxBrickObjectType);
					if(isObject(%obj = firstWord(%ray)))
					{
						if(!SpleefArena.isMember(%obj)) return;
						if(%obj.powerup !$= "" || %obj.trappedPowerup) return;   //Can't trap legit powerups.
						%this.playThread(0, "activate2");
						//Should this be delayed? Should it act like it's really the only one (take the powerup variable)?
						if(%obj.origColor $= "") %obj.origColor = %obj.getColorID();
						%obj.setColor(getRandom(7, 13)); %obj.setColorFX(4);
						%obj.setEmitter(PongExplosionEmitter);
						%obj.trappedPowerup = 1;
						%obj.TrapClient = %cl;
						%obj.nukeTrap = 1;
					}
					else return;
					%this.powerupCharge--; %cl.showPowerupPrint();
				case "Blink!":
					if(!%tog || %this.powerupCharge < 1) return;
					%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
					%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 240)), $Typemasks::fxBrickObjectType);
					if(isObject(%obj = firstWord(%ray)))
					{
						if(!SpleefArena.isMember(%obj)) return;
						%this.setTransform(vectorAdd(%obj.getPosition(), "0 0 0.15") SPC getWords(%this.getTransform(), 3, 6));
						%this.playThread(0, "activate2"); %obj.noBreakTime = getSimTime();
					}
					else return;
					%this.powerupCharge--; %cl.showPowerupPrint();
				case "Sniper!":
					if(!%tog || %this.powerupCharge < 1) return;
					%this.UseBlast(1, 240);
				case "GodTP":
					if(!%tog) return;
					%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
					%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 240)), $Typemasks::fxBrickObjectType);
					if(isObject(%obj = firstWord(%ray)))
					{
						if(!SpleefArena.isMember(%obj)) return;
						%this.setTransform(vectorAdd(%obj.getPosition(), "0 0 0.15") SPC getWords(%this.getTransform(), 3, 6));
						%this.playThread(0, "activate2");
						%this.noBreaking.noBreakGod = "";
						if(isObject(%this.noBreaking))
							%this.noBreaking.CheckIsland(%this.client);
						%obj.noBreakGod = %this; %this.noBreaking = %obj;
					}
					else return;
					%cl.showPowerupPrint();
			}
		}
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function GameConnection::createPlayer(%cl, %trans)
	{
		if(SpleefArena.getCount() != 0)
		{
			%dir = getRandom(0, 7);
			%ang = %dir * (6.28319 / 8) - 3.14159265;
			%brick = SpleefArena.getObject(getRandom(0, SpleefArena.getCount() - 1));
			if(SpleefArena.useLives && %cl.SpleefLives <= 0)
			{
				%cl.setControlObject(%cam = %cl.camera);
				%cam.setTransform(vectorAdd(%brick.getPosition(), "0 0 2.15")@" 0 0 1 "@%ang);
				return;
			}
			%trans = vectorAdd(%brick.getPosition(), "0 0 0.15")@" 0 0 1 "@%ang;
		}
		commandToClient(%cl, 'clearCenterPrint');
		%cl.bottomPrint("\c6NONE\c7 (No Special)");
		Parent::createPlayer(%cl, %trans);
		if(!isObject(%pl = %cl.player)) return;
		%pl.setDatablock(PlayerNoJet); %pl.clearTools();
		%pl.tool0 = ButterflyKnifeItem.getID();
		messageClient(%cl, 'MsgItemPickup', '', 0, ButterflyKnifeItem.getID(), 1);
		commandToClient(%cl, 'setBuildingDisabled', 1);
		commandToClient(%cl, 'setPaintingDisabled', 1);
		%pl.SpleefLoop(%pl.getPosition());
	}
	
	function GameConnection::onDeath(%cl, %col, %killer, %damageType, %damageArea)
	{
		commandToClient(%cl, 'clearBottomPrint');
		if(isObject(%pl = %cl.player) && %pl.fellThrough !$= "")
		{
			if(isObject(%obj = %pl.fellThrough.lastDropper))
			{
				%killer = %obj;
				if(isObject(%obj.player))
					%col = %obj.player;
				if(%cl != %obj) %obj.score++;
			}
			%pl.setVelocity(vectorScale(getFireAimVector(%pl.getPosition(), %pl.fellThrough.getPosition(), 1, 50), 50));
		}
		Parent::onDeath(%cl, %col, %killer, %damageType, %damageArea);
		%cl.camera.schedule(5000, "setMode", "Observer");
		messageClient(%cl, 'MsgYourDeath', '', %damageType, %cl.name, %killer.name, 0);
		%cl.SpleefLives--;
		if(SpleefArena.useLives && %cl.SpleefLives <= 0)
		{
			%cl.centerPrint("<br><br><br><br>\c5Out of lives!<br>\c5Please wait for the next round.");
			if(!isEventPending($SpleefRestore))
			{
				%count = ClientGroup.getCount();
				for(%i=0;%i<%count;%i++)
				{
					%cl = ClientGroup.getObject(%i);
					if(!isObject(%pl = %cl.player) || %pl.getState() $= "DEAD")
						continue;
					%livingPlayers++;
					%lastStanding = %cl;
				}
				if(%livingPlayers > 1) return;
				else if(%livingPlayers == 1) messageAll('', "\c6The victor is \c2"@%lastStanding.name@"\c6! Resetting in five seconds!");
				else messageAll('', "\c6Everyone has died! Resetting in five seconds!");
				$SpleefRestore = schedule(5000, 0, "RestoreSpleefArena");
			}
		}
	}
	
	function GameConnection::onClientEnterGame(%cl)
	{
		%cl.spleefLives = 0;
		Parent::onClientEnterGame(%cl);
		if(!isEventPending($SpleefRestore))
		{
			%count = ClientGroup.getCount();
			for(%i=0;%i<%count;%i++)
			{
				%cl = ClientGroup.getObject(%i);
				if(!isObject(%pl = %cl.player) || %pl.getState() $= "DEAD")
					continue;
				%livingPlayers++;
				%lastStanding = %cl;
			}
			if(%livingPlayers > 1) return;
			else if(%livingPlayers == 1) messageAll('', "\c6The victor is \c2"@%lastStanding.name@"\c6! Resetting in five seconds!");
			else messageAll('', "\c6Everyone has died! Resetting in five seconds!");
			$SpleefRestore = schedule(5000, 0, "RestoreSpleefArena");
		}
	}
	
	function GameConnection::onClientLeaveGame(%cl)
	{
		if(SpleefArena.useLives && isObject(%cl.player))
		{
			%count = ClientGroup.getCount();
			if(%count == 0) return;
			for(%i=0;%i<%count;%i++)
			{
				%this = ClientGroup.getObject(%i);
				if(%this.hasSpawnedOnce) %sayStuff = 1;
				if(!isObject(%pl = %this.player) || %pl.getState() $= "DEAD")
					continue;
				%livingPlayers++;
				%lastStanding = %this;
			}
			if(%sayStuff && %livingPlayers <= 1)
			{
				if(%livingPlayers == 1) messageAll('', "\c6The victor is \c2"@%lastStanding.name@"\c6! Resetting in five seconds!");
				else messageAll('', "\c6Everyone has died! Resetting in five seconds!");
				if(!isEventPending($SpleefRestore)) $SpleefRestore = schedule(5000, 0, "RestoreSpleefArena");
			}
		}
		Parent::onClientLeaveGame(%cl);
	}
	
	function Observer::onTrigger(%data, %this, %trig, %tog)
	{
		if(SpleefArena.useLives && %this.getControllingClient().SpleefLives <= 0) return;
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
};
activatePackage("SpleefArena");

function Player::SpleefLoop(%pl, %last)
{
	cancel(%pl.SpleefLoop);
	%curr = %pl.getPosition();
	%arena = SpleefArena;
	if(getWord(%last, 2) >= 16.3 && getWord(%curr, 2) < 16.3)
	{
		%avg = vectorScale(vectorAdd(getWords(%curr, 0, 1), getWords(%last, 0, 1)), 0.5);
		%x = mFloatLength((getWord(%avg, 0) - 2) / 4, 0) * 4 + 2;
		%y = mFloatLength((getWord(%avg, 1) - 2) / 4, 0) * 4 + 2;
		%pos = %x SPC %y SPC 16.3;
		for(%i=0;%i<%arena.deadBricks;%i++)
		{
			%brick = %arena.deadBrick[%i];
			if(vectorDist(%brick.getPosition(), %pos) <= 0.05)
			{ %pl.fellThrough = %brick; break; }
		}
	}
	if((%z = getWord(%curr, 2)) > 16.3 && %z < 16.8)
	{
		%x = mFloatLength((getWord(%curr, 0) - 2) / 4, 0) * 4 + 2;
		%y = mFloatLength((getWord(%curr, 1) - 2) / 4, 0) * 4 + 2;
		%pos = %x SPC %y SPC 16.3;
		%count = %arena.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%brick = %arena.getObject(%i);
			if(vectorDist(%brick.getPosition(), %pos) <= 0.05)
			{ %iceTest = %brick; break; }
		}
		if(isObject(%iceTest))
		{
			if(%z > 16.4 && %z < 16.45) %pl.hasDJumped = 0;
			if(%iceTest.icyTile)
			{
				%pl.slipping = 1;
				%pl.setDatablock(SlidingPlayer);
			}
			else
			{
				%pl.slipping = 0;
				if(%pl.currentPowerup $= "Jet" && %pl.powerupCharge > 0 && %pl.allowJetting)
					%pl.setDatablock(PlayerStandardArmor);
				else %pl.setDatablock(PlayerNoJet);
			}
		}
		%flatVel = getWords(%pl.getVelocity(), 0, 1);
		if(%pl.currentPowerup $= "Blink" && %pl.powerupCharge > 0 && !%pl.slipping && vectorLen(%flatVel) >= 3)
		{
			for(%i=0;%i<%arena.deadBricks;%i++)
			{
				%brick = %arena.deadBrick[%i];
				if(vectorDist(%brick.getPosition(), %pos) <= 0.05)
				{ %blink = 1; %gap = %brick; break; }
			}
			if(%blink)
			{
				%ang = mAtan(getWord(%flatVel, 0), getWord(%flatVel, 1));
				%dir = %ang; %dir += 3.14159265; %dir /= 6.28319 / 8;
				%dir = mFloatLength(%dir, 0); if(%dir == 8) %dir = 0;
				%dirList = "0 -4	-4 -4	-4 0	-4 4	0 4	4 4	4 0	4 -4";
				%blinkDir = getField(%dirList, %dir);
				%tiles = 3; %diminish = 3; %cost++; %unsafe = 1;
				while(%unsafe)
				{
					if(%tiles <= 0)
					{
						if(%pl.powerupCharge <= %cost) break;
						%diminish = getMax(%diminish - 1, 1);
						%tiles += %diminish; %cost++;
					}
					%pos = vectorAdd(%pos, %blinkDir); %unsafe = 0;
					for(%i=0;%i<%arena.deadBricks;%i++)
					{
						%brick = %arena.deadBrick[%i];
						if(vectorDist(%brick.getPosition(), %pos) <= 0.05)
						{ %unsafe = 1; break; }
					}
					%tiles--; %totalTiles++;
				}
				if(!%unsafe)
				{
					%count = %arena.getCount();
					for(%i=0;%i<%count;%i++)
					{
						%brick = %arena.getObject(%i);
						if(vectorDist(%brick.getPosition(), %pos) <= 0.05)
						{ %canBlink = 1; break; }
					}
				}
				else %canBlink = 1;
				if(%canBlink)
				{
					%pl.powerupCharge -= %cost;
					%blinkPos = vectorAdd(%pos, vectorScale(%blinkDir, -0.4));
					%pl.setTransform(getWords(%blinkPos, 0, 1)@" 16.45 "@getWords(%pl.getTransform(), 3, 6));
					if(isObject(%cl = %pl.client))
						%cl.bottomPrint("<color:0000FF>BLINK\c6 ("@%pl.powerupCharge@" step"@(%pl.powerupCharge==1?"":"s")@")");
				}
			}
		}
	}
	else
	{
		%pl.slipping = 0;
		if(%pl.currentPowerup $= "Jet" && %pl.powerupCharge > 0 && %pl.allowJetting)
			%pl.setDatablock(PlayerStandardArmor);
		else %pl.setDatablock(PlayerNoJet);
	}
	%pl.SpleefLoop = %pl.schedule(16, "SpleefLoop", %curr);
}

function Player::Spleef_JetMonitor(%pl, %last)
{
	cancel(%pl.Spleef_JetLoop);
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	if(%pl.currentPowerup $= "JET")
	{
		%origCharge = %pl.powerupCharge;
		%pl.powerupCharge -= %time;
		if(%pl.powerupCharge <= 0)
		{
			%pl.setDatablock(%pl.slipping ? SlidingPlayer : PlayerNoJet);
			%pl.powerupCharge = 0;
			%pl.allowJetting = 0;
		}
		else
		{
			%a = -20;   //Force of gravitation in Blockland.
			%b = getWord(%pl.getVelocity(), 2);   //Upwards velocity.
			%c = getWord(%pl.getPosition(), 2) - 40;   //Initial height relative to our cap.
			%d = ((%b * %b) - (4 * %a * %c));   //Determinant.
			if(%d >= 0)
			{
				%s0 = (-%zVel + mSqrt(%d)) / %zAccel * 2;
				%s1 = (-%zVel - mSqrt(%d)) / %zAccel * 2;
				if(%s0 > 0 || %s1 > 0) { %pl.setDatablock(%pl.slipping ? SlidingPlayer : PlayerNoJet); %pl.powerupCharge = %origCharge; %pl.allowJetting = 0; }
				else { %pl.setDatablock(PlayerStandardArmor); %pl.allowJetting = 1; }
			}
			else { %pl.setDatablock(PlayerStandardArmor); %pl.allowJetting = 1; }
		}
		%value = mFloatLength(mCeil(%pl.powerupCharge * 10) / 10, 1);
		if(%value != %pl.lastJetValue && isObject(%cl = %pl.client)) { %cl.bottomPrint("<color:FFFF00>JET\c6 ("@%value@" second"@(%value==1?"":"s")@")"); %pl.lastJetValue = %value; }
	}
	%pl.Spleef_JetLoop = %pl.schedule(16, "Spleef_JetMonitor", %now);
}

function Player::DJumpCheck(%pl, %velA)
{
	if(%pl.slipping || !isObject(%cl = %pl.client)) return;
	%velB = %pl.getVelocity();
	%zDiff = getWord(%velB, 2) - getWord(%velA, 2);
	if(%zDiff >= 10) { %pl.hasDJumped = 0; return; }
	else if(!%pl.hasDJumped || %pl.currentPowerup $= "DJump!")
	{
		%pl.setVelocity(getWords(%pl.getVelocity(), 0, 1)@" 12");
		serverPlay3D(JumpSound, %pl.getPosition()); %pl.hasDJumped++;
	}
	else return; %pl.powerupCharge -= %pl.hasDJumped;
	%cl.showPowerupPrint();
}

registerOutputEvent("fxDtsBrick", "DoSpleefEvents", "", 1);
function fxDtsBrick::DoSpleefEvents(%brick, %cl)
{
	if(!isObject(%pl = %cl.player)) return;
	if(vectorDist(%brick.noBreakTime, getSimTime()) <= 2000) return;
	if(isObject(%brick.noBreakGod)) return;
	if(%brick.icyTile) return;
	if(%brick.powerup !$= "")
	{
		if((%brick.powerup !$= "???") && (%brick.powerup !$= %pl.currentPowerup) && (%brick.powerup@"!" !$= %pl.currentPowerup))
		{
			cancel(%pl.Spleef_JetLoop);
			%pl.setDatablock(PlayerNoJet);
			if(!$Pref::Server::Spleef::Tier2)
				%pl.currentPowerup = %brick.powerup;   //Normal gameplay
			else %pl.currentPowerup = %brick.powerup@"!";   //Immediate T2 gameplay
			%pl.powerupCharge = 0;
		}
		if(%brick.powerup@"!" $= %pl.currentPowerup)
		{
			%cl.showPowerupInfo();
			if(%brick.powerup $= "Mine")
				%pl.powerupCharge += ($Pref::Server::Spleef::Tier2 ? 1 : 0.25);
			else %pl.powerupCharge += ($Pref::Server::Spleef::Tier2 ? 3 : 1);
			%cl.showPowerupPrint();
		}
		else
		{
			switch$(%brick.powerup)
			{
				case "Blast":
					%cl.showPowerupInfo();
					%pl.powerupCharge += 3;
				//	if(%pl.powerupCharge > 15)
				//	{
				//		%pl.currentPowerup = "Blast!";
				//		%pl.powerupCharge = 3;
				//	}
					%cl.showPowerupPrint();
				case "Mine":
					%cl.showPowerupInfo();
					%pl.powerupCharge++;
				//	if(%pl.powerupCharge > 3)
				//		%pl.powerupCharge = 3;
					%cl.showPowerupPrint();
				case "Jet":
					%cl.showPowerupInfo();
					%pl.powerupCharge += 4;
					%pl.setDatablock(PlayerStandardArmor);
					%cl.showPowerupPrint();
				case "Regen":
					%cl.showPowerupInfo();
					%pl.powerupCharge += 3;
					%cl.showPowerupPrint();
				case "Icy":
					%cl.showPowerupInfo();
					%pl.powerupCharge++;
				//	if(%pl.powerupCharge > 5)
				//		%pl.powerupCharge = 5;
					%cl.showPowerupPrint();
				case "Blink":
					%cl.showPowerupInfo();
					%pl.powerupCharge += 3;
				//	if(%pl.powerupCharge > 15)
				//	{
				//		%pl.currentPowerup = "Blink!";
				//		%pl.powerupCharge = 3;
				//	}
					%cl.showPowerupPrint();
				case "Sniper":
					%cl.showPowerupInfo();
					%pl.powerupCharge += 2;
					%cl.showPowerupPrint();
				case "???": %pl.GetRandomPowerup(getSimTime());
				case "DJump":
					%cl.showPowerupInfo();
					%pl.powerupCharge += 3;
					%cl.showPowerupPrint();
			}
		}
	}
	if(!%brick.trappedPowerup) %brick.KillSpleefBrick(%cl);
	else if(!isEventPending(%brick.trapLoop)) %brick.ActivateTrap(getSimTime(), getSimTime());
}

function fxDtsBrick::KillSpleefBrick(%brick, %cl)
{
	if(vectorDist(%brick.noBreakTime, getSimTime()) <= 2000) return 0;
	if(isObject(%brick.noBreakGod)) return;
	if(%brick.trappedPowerup) { %brick.DetonateTrap(); return 1; }
	%brick.fakeKillBrick("0 0 0", 0);   //Velocity and time. A time of 0 means 'forever'.
	%brick.deadSched = %brick.schedule(3000, "disappear", -1);
	if(!isObject(SpleefArena))
		CreateSpleefHandler();
	if(!SpleefArena.isMember(%brick)) return;
	SpleefArena.deadBrick[-1+SpleefArena.deadBricks++] = %brick;
	SpleefArena.remove(%brick);
	if(%brick.powerup !$= "")
	{ SpleefArena.powerup[%brick.powerup] = ""; SpleefArena.lastSpawn_[%brick.powerup] = getSimTime(); }
	%brick.powerup = ""; %brick.trappedPowerup = 0; %brick.lastDropper = %cl;
	%brick.CheckNeighbors();
	for(%i=0;%i<%brick.neighbors;%i++)
	{
		%obj = %brick.neighbor[%i];
		if(SpleefArena.isMember(%obj))
			%obj.CheckIslandSched = %obj.schedule(0, "CheckIsland", %cl);
	}
	return 1;
}

function fxDtsBrick::CheckNeighbors(%brick)
{
	if(%brick.neighbors == 0)
	{
		%pos = %brick.getPosition();
		%mask = $Typemasks::fxBrickAlwaysObjectType;
		%ray0 = "4 0 0";
		%ray1 = "0 4 0";
		%ray2 = "-4 0 0";
		%ray3 = "0 -4 0";
		for(%i=0;%i<4;%i++)
			if(isObject(%obj = firstWord(containerRaycast(%pos, vectorAdd(%pos, %ray[%i]), %mask))))
				if(getWord(%obj.getPosition(), 2) == 16.3)
					%brick.neighbor[-1+%brick.neighbors++] = %obj;
	}
}

function fxDtsBrick::CheckIsland(%brick, %cl)
{
	if($Debug) talk("Checking "@%brick@" for island");
	%list[-1+%list++] = %brick;
	%fall[-1+%fall++] = %brick;
	%checked[%brick] = 1;
	%area = 1;
	while(%list > 0)
	{
		%check = %list[%list--];
		%check.CheckNeighbors();
		for(%i=0;%i<%check.neighbors;%i++)
		{
			%obj = %check.neighbor[%i];
			if(SpleefArena.isMember(%obj) && !%checked[%obj])
			{
				%list[-1+%list++] = %obj;
				%fall[-1+%fall++] = %obj;
				%checked[%obj] = 1; %area++;
			}
		}
		if($Debug) talk(%area);
		if(%area > $Pref::Server::Spleef::MinIsleArea) return;
	}
	if($Debug) talk("Killing "@%area@" bricks...");
	for(%i=0;%i<%fall;%i++)
		%fall[%i].KillSpleefBrick(%cl);
}

function fxDtsBrick::ActivateTrap(%brick, %start, %last)
{
	cancel(%brick.trapLoop);
	if(!%brick.trappedPowerup) return;
	if(%brick.nukeTrap) { %brick.ActivateNuke(%start, %last); return; }
	%now = getSimTime();
	%dist0 = vectorDist(%start, %last);
	%dist1 = vectorDist(%start, %now);
	if(%dist0 < 250 && %dist1 >= 250)
		serverPlay3D(Beep_EKG_Sound, %brick.getPosition());
	else if(%dist0 < 500 && %dist1 >= 500)
		serverPlay3D(Beep_EKG_Sound, %brick.getPosition());
	else if(%dist0 < 750 && %dist1 >= 750)
		serverPlay3D(Beep_EKG_Sound, %brick.getPosition());
	else if(%dist0 < 1000 && %dist1 >= 1000)
		serverPlay3D(Beep_EKG_Sound, %brick.getPosition());
	else if(%dist0 < 1250 && %dist1 >= 1250)
	{ %brick.DetonateTrap(); return; }
	%brick.trapLoop = %brick.schedule(16, "ActivateTrap", %start, %now);
}

function fxDtsBrick::DetonateTrap(%brick)
{
	if(!%brick.trappedPowerup) return;
	if(%brick.nukeTrap) { %brick.DetonateNuke(); return; }
	initContainerBoxSearch(%brick.getPosition(), "16 16 0.05", $Typemasks::fxBrickObjectType);
	%brick.trappedPowerup = 0;
	while(isObject(%obj = containerSearchNext()))
		if(SpleefArena.isMember(%obj) && %obj.trappedPowerup)
			%obj.trapLoop = %obj.schedule(250, "DetonateTrap");
	initContainerBoxSearch(%brick.getPosition(), "8 8 0.05", $Typemasks::fxBrickObjectType);
	while(isObject(%obj = containerSearchNext()))
		if(SpleefArena.isMember(%obj) && !%obj.trappedPowerup)
			%obj.KillSpleefBrick(%brick.TrapClient);
	serverPlay3D(RocketExplodeSound, %brick.getPosition());
}

function fxDtsBrick::ActivateNuke(%brick, %start, %last)
{
	cancel(%brick.trapLoop);
	if(!%brick.trappedPowerup) return;
	%now = getSimTime();
	%dist0 = vectorDist(%start, %last);
	%dist1 = vectorDist(%start, %now);
	if(%dist0 < 250 && %dist1 >= 250)
		serverPlay3D(Beep_NoWay_Sound, %brick.getPosition());
	else if(%dist0 < 2000 && %dist1 >= 2000)
	{ %brick.DetonateTrap(); return; }
	%brick.trapLoop = %brick.schedule(16, "ActivateNuke", %start, %now);
}

function fxDtsBrick::DetonateNuke(%brick)
{
	if(!%brick.trappedPowerup) return;
	initContainerBoxSearch(%brick.getPosition(), "24 24 0.05", $Typemasks::fxBrickObjectType);
	%brick.trappedPowerup = 0;
	while(isObject(%obj = containerSearchNext()))
		if(SpleefArena.isMember(%obj))
			if(%obj.trappedPowerup) %obj.schedule(250, "DetonateTrap");
			else %obj.KillSpleefBrick(%brick.TrapClient);
	serverPlay3D(RocketExplodeSound, %brick.getPosition());
}

datablock PlayerData(SlidingPlayer : PlayerNoJet)
{
	runForce = 750;
	jumpForce = 250;
	runSurfaceAngle = 0;
	jumpSurfaceAngle = 0;
};

exec("./GravProj.cs");
exec("./Lottery.cs");
exec("./Powerups.cs");

//Tacked on for release - there's got to be a better way to detect when the save has finished loading
schedule(50, 0, "spleefLoadCheck", 0);
function spleefLoadCheck(%prevBricks)
{
	%groups = MainBrickgroup.getCount();
	for(%i=0;%i<%groups;%i++)
		%count += MainBrickgroup.getObject(%i).getCount();
	if(%count != %prevBricks)
		schedule(50, 0, "spleefLoadCheck", %count);
	else CreateSpleefHandler();
}